#ifndef   TDC_GP22_H
#define   TDC_GP22_H
#include "config.h"

#define GP22_Start_TOF                0x01
#define GP22_Start_Temp               0x02
#define GP22_Start_Cal_Resonator      0x03
#define GP22_Start_Cal_TDC            0x04
#define GP22_Start_TOF_Restart        0x05
#define GP22_Init                     0x70     
#define GP22_POR                      0x50

#define ReadRES_0                     0xb0
#define ReadRES_1                     0xb1
#define ReadRES_2                     0xb2
#define ReadRES_3                     0xb3
#define ReadSTAT                      0xb4
#define ReadREG_1                     0xb5
#define ReadPW1ST                     0xb8

#define FireUpMod                     0x01
#define FireDownMod                   0x02

#define TDC_Enable      GPIO_Init(TDC_RST_PORT, TDC_RST_PIN, GPIO_Mode_Out_PP_High_Fast)
#define TDC_Disable     GPIO_Init(TDC_RST_PORT, TDC_RST_PIN, GPIO_Mode_Out_PP_Low_Fast)
#define SPI_Enable      GPIO_Init(SPI_NSS_PORT, SPI_NSS_PIN, GPIO_Mode_Out_PP_Low_Fast)
#define SPI_Disable     GPIO_Init(SPI_NSS_PORT, SPI_NSS_PIN, GPIO_Mode_Out_PP_High_Fast)
#define TDC_FireUp      GPIO_Init(TDC_ALT_PORT, TDC_ALT_PIN, GPIO_Mode_Out_PP_High_Fast)
#define TDC_FireDown    GPIO_Init(TDC_ALT_PORT, TDC_ALT_PIN, GPIO_Mode_Out_PP_Low_Fast)
#define OPA_Disable     GPIO_Init(OPA_PD_PORT, OPA_PD_PIN, GPIO_Mode_Out_PP_Low_Fast)
#define OPA_Enable      GPIO_Init(OPA_PD_PORT, OPA_PD_PIN, GPIO_Mode_Out_PP_High_Fast)

extern uint8_t RES0Buf[4];
extern uint8_t RES1Buf[4];
extern uint8_t RES2Buf[4];
extern uint8_t RES3Buf[4];
extern uint8_t STATBuf[2];
extern uint8_t REG1Buf[1];
extern uint8_t PW1STBuf[1];

extern uint8_t TDC_INTFlag;

extern void Delay(__IO uint16_t nCount);
extern void SpiInit();
extern void WriteSPIData(uint8_t *data,uint16_t dataLen);
extern void ReadSPIData(uint8_t *data,uint16_t dataLen);
extern void OpCodeGP22(uint8_t data);
extern void ConfigGP22(uint8_t addr, uint32_t data);
extern void ReadGP22(uint8_t *data,uint16_t Symbol);
extern void StartGP22Fire(uint8_t Mod_Sel);
extern void StartGP22Temp();
extern void ReadGP22Results();
extern void ShutDownTDC();

#endif